#include <stdio.h>

#define FIM 0

float salario_medio = 0,
      idade_media = 0;
int mulheres = 0,
    idade_max = 0,
    idade_min = 0;

void mflush(void);
void calc_salarioMedio (float, int);
void calc_idadeMedia (int, int);
void calc_idades (int);
void calc_mulheres (int, float, char);

/***************************
 * Programa principal
 ***************************
 */

main () 
{

  float salario;
  int idade = 0,
      habitantes = 0,
      filhos;
  char sexo;

  do {
    printf ("Entre dados do habitante (idade, sexo, salario, filhos): ");
    if (scanf ("%d %c %f %d", &idade, &sexo, &salario, &filhos) == 4) {
      if (idade != FIM) {
	++habitantes;

	if ( sexo != 'f' && sexo != 'F' && sexo != 'm' && sexo != 'M') {
	  printf ("\t Sexo deve ser M, m, F ou f\n");
	  mflush();
	  continue;
	}

	calc_salarioMedio (salario, 0);
	calc_idadeMedia (idade, 0);
	calc_idades (idade);
	calc_mulheres (filhos, salario, sexo);
      }
    }
    else if (idade != FIM) {
      printf ("\t Dados de entrada errados ou incompletos\n");
      mflush();
    }

  } while (idade != FIM);

  if (habitantes) {
    calc_salarioMedio (0.0, habitantes);
    calc_idadeMedia (0, habitantes);
    
    printf ("MEDIA SALARIAL = %f\n", salario_medio);
    printf ("IDADES: max = %d, min = %d, media = %f\n", idade_max, idade_min, idade_media);
    printf ("Mulheres com 3 filhos e renda ate' R$500,00 = %d\n", mulheres);
  }
}

/**********************************************************************
 *  Funcao calc_salarioMedio
 * 
 *  Acao:       Calcula salario medio de um conjunto de habitantes de
 *              uma cidade
 *  Entrada:    salario de uma pessoa e numero de habitantes
 *  Saida:      media na variavel global salario_medio
 *  Suposicoes: numero de habitantes >= 0
 *  Algoritmo:  Se numero de habitantes eh 0 (zero), soma salario ao
 *                 total em variavel global salario_medio.
 *              Quando numero de habitantes for != 0, calcula a media.
 **********************************************************************
 */
void calc_salarioMedio (float sal, int hab)
{
  if (hab != 0)
    salario_medio /= hab;
  else
    salario_medio += sal;
}

/**********************************************************************
 *  Funcao calc_idadeMedia
 * 
 *  Acao:       Calcula idade media de um conjunto de habitantes de
 *              uma cidade
 *  Entrada:    idade de uma pessoa e numero de habitantes
 *  Saida:      media na variavel global idade_media
 *  Suposicoes: numero de habitantes >= 0
 *  Algoritmo:  Se numero de habitantes eh 0 (zero), soma idade ao
 *                 total em variavel global idade_media.
 *              Quando numero de habitantes for != 0, calcula a media.
 **********************************************************************
 */
void calc_idadeMedia (int id, int hab)
{
  if (hab != 0)
    idade_media /= hab;
  else
    idade_media += id;
}

/**********************************************************************
 *  Funcao calc_idades
 * 
 *  Acao:       Calcula idade maximo e minima de um conjunto de
 *              habitantes de uma cidade
 *  Entrada:    idade de uma pessoa
 *  Saida:      idade maxima na variavel global idade_max
 *              idade minima na variavel global idade_min
 **********************************************************************
 */
void calc_idades (int id)
{
  int temp;

  if (idade_max < id) {
    temp = idade_max;
    idade_max = id;
    id = temp;
  }

  if (idade_min == 0)
    idade_min = idade_max;

  if (idade_min > id)
    idade_min = id;

}

/**********************************************************************
 *  Funcao calc_mulheres
 * 
 *  Acao:       Calcula quantidade de mulheres com 3 filhos e salario
 *              ateh R$ 500,00
 *  Entrada:    numero de filhos, salario e sexo de uma pessoa
 *  Saida:      quantidade de mulheres na variavel global mulheres
 **********************************************************************
 */
void calc_mulheres (int filhos, float sal, char sexo)
{
  if ((sexo == 'F' || sexo == 'f') && filhos == 3 && sal <= 500.00)
    ++mulheres;

}

/**********************************************************************
 *  Funcao mflush
 * 
 *  Acao:       esvazia buffer de entrada
 *  Entrada:    nenhuma
 *  Saida:      nenhuma
 **********************************************************************
 */
void mflush()
{
  while (getchar() != '\n');
}

